var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.resolve = resolve;
exports['default'] = modularize;

var _fs = require('./fs');

var _fs2 = _interopRequireWildcard(_fs);

var _lodashModules = require('./lodashModules');

var _lodashModules2 = _interopRequireWildcard(_lodashModules);

var _parseForModules = require('./parseForModules');

var _parseForModules2 = _interopRequireWildcard(_parseForModules);

var _flatten$includes$isArray$uniq = require('lodash');

var _Promise = require('bluebird');

var _Promise2 = _interopRequireWildcard(_Promise);

var _esperantoBuild = require('./esperanto-build');

var _esperantoBuild2 = _interopRequireWildcard(_esperantoBuild);

var _cliBuild = require('./cli-build');

var _cliBuild2 = _interopRequireWildcard(_cliBuild);

var _Error = require('./Error');

var _Error2 = _interopRequireWildcard(_Error);

var glob = _Promise2['default'].promisify(require('glob'));

function resolve(files, options) {
  return _Promise2['default'].map(files, function (file) {
    return _fs2['default'].readFileAsync(file).then(function (blob) {
      return _parseForModules2['default'](blob, file, options);
    }).then(function (methods) {
      if (_flatten$includes$isArray$uniq.includes(methods, 'chain')) {
        throw new _Error2['default']('Chaining syntax is not yet supported', file);
      }
      return methods;
    });
  }).then(function (methods) {
    return _flatten$includes$isArray$uniq.uniq(_flatten$includes$isArray$uniq.flatten(methods));
  });
}

function modularize(fileGlob, options) {
  var files = (_flatten$includes$isArray$uniq.isArray(fileGlob) ? _Promise2['default'].resolve(fileGlob) : glob(fileGlob)).then(function (files) {
    return resolve(files, options);
  });

  return _Promise2['default'].all([files, _lodashModules2['default']]).spread(function (methods, modules) {
    // What to do with the resulting methods (e.g. export, list, etc)
    if (options.list) {
      return methods;
    }
    var code = undefined;
    if (options.compile) {
      code = _cliBuild2['default'](methods, options);
    } else {
      code = _esperantoBuild2['default'](methods, modules, options).code;
    }
    var $code = _Promise2['default'].resolve(code);
    if (options.output) {
      return $code.then(function (code) {
        return _fs2['default'].writeFileAsync(options.output, code);
      }).then(function () {
        return $code;
      });
    }
    return $code;
  });
}

module.exports = modularize;